*** 
*** ReFox MMII (Win) #UK813760  OSCAR VALENTE  LINCKER S.R.L. [VFP70]
***
PARAMETER pmau_bc
IF .F.
     _refox_ = (9876543210^1)
ENDIF
_vfvobgltcb1 = IIF(m_lan = 'V',  ;
               'Chi tieu',  ;
               ecode2string('GLTCB0001'))
_vfvobgltcb2 = IIF(m_lan = 'V',  ;
               'Ma so',  ;
               ecode2string('GLTCB0002'))
_vfvobgltcb3 = IIF(m_lan = 'V',  ;
               'Chi tieu',  ;
               ecode2string('GLTCB0003'))
_vfvobgltcb4 = IIF(m_lan = 'V',  ;
               'Ma so',  ;
               ecode2string('GLTCB0004'))
_vfvobgltcb5 = 'Ngay_ct'
_vfvobgltcb6 = 'Ngay_ct'
_vfvobgltcb7 = IIF(m_lan = 'V',  ;
               'Thuyet minh',  ;
               ecode2string('GLTCB0016'))
_vfvobgltcbt1 = IIF(m_lan = 'V',  ;
                'Tong cong',  ;
                ecode2string('GLTCB0005'))
_vfvobgltcbt2 = IIF(m_lan = 'V',  ;
                'Tong cong',  ;
                ecode2string('GLTCB0006'))
_vfvobgltcbt3 = IIF(m_lan = 'V',  ;
                'Tong cong(NT)',  ;
                ecode2string('GLTCB0007'))
m_rfyn = .T.
IF  .NOT. m_refresh
     m.ma_dvcs = ''
     m.rep_vnd_nt1 = 1
     m.nhan_huy = 1
     m.ngay_ct1 = m_ngay_ct1
     m.ngay_ct2 = m_ngay_ct2
     m.ngay_ct0 = m.ngay_ct1 -  ;
                  (m.ngay_ct2 -  ;
                  m.ngay_ct1)
     m.ngay_ct3 = DATE()
     m.luy_ke = .F.
     m.mau_rpt = '1'
     m.mau_bc = pmau_bc
     IF YEAR(m.ngay_ct0) <>  ;
        YEAR(m.ngay_ct1)
          m.ngay_ct0 = getstartdate(m.ngay_ct1)
     ENDIF
     SELECT 0
     USE (k_mau + 'dmmaubc')  ;
         ALIAS m_dmmaubc
     SET FILTER TO ma_maubc = m.mau_bc
     DO FORM (k_scx + 'GLTC48B')
     m.luy_ke = .F.
     m_ngay_dau_nam = getstartdate(m.ngay_ct0)
     m.tcodename = k_mau +  ;
                   ALLTRIM(m_dmmaubc.file_maubc)
     USE IN m_dmmaubc
     IF m.nhan_huy <> 1
          RETURN
     ENDIF
     _check = .T.
     USE NOUPDATE (m.tcodename)  ;
         ALIAS acheck
     DO kiem_tra_chi_tieu IN  ;
        (k_fxp + 'smrptlib') WITH  ;
        'aCheck', _check
     IF  .NOT. _check
          msgbox(IIF(m_lan = 'V',  ;
                'Hay kiem tra lai, cac chi tieu khai bao chua dung',  ;
                'Check again, data in the table of report is invalid' ;
                ),31,m_itg_ver)
          USE IN acheck
          RETURN
     ENDIF
     USE IN acheck
     SAVE TO (k_tmp +  ;
          'tRPMemvarList') ALL
ELSE
     RESTORE FROM (k_tmp +  ;
             'tRPMemvarList')  ;
             ADDITIVE
ENDIF
WAIT WINDOW NOWAIT m_process
m_ngay_ct1 = m.ngay_ct1
m_ngay_ct2 = m.ngay_ct2
DO rpbalance WITH m.tcodename
WAIT CLEAR
DO browsetable
m_refresh = .F.
RETURN
ENDPROC
*
PROCEDURE RPBalance
LPARAMETERS stablecode
PRIVATE curselect, currecno
curselect = SELECT()
USE NOUPDATE (stablecode) ALIAS  ;
    akqt IN 0
DO sorttable WITH 'aKqt', (k_tmp +  ;
   'tKqt')
USE EXCLUSIVE (k_tmp + 'tKqt')  ;
    ALIAS tkqt ORDER Order IN 0
ngay0_kn = IIF(m_ngay_bd >  ;
           getstartdate(m.ngay_ct1),  ;
           m_ngay_bd,  ;
           getstartdate(m.ngay_ct1))
ngay0_kt = IIF(m_ngay_bd >  ;
           getstartdate(m.ngay_ct0),  ;
           m_ngay_bd,  ;
           getstartdate(m.ngay_ct0))
SELECT tkqt
SCAN FOR EMPTY(cach_tinh) .AND.   ;
     .NOT. (EMPTY(tk_no) .AND.  ;
     EMPTY(tk_co))
     WAIT WINDOW NOWAIT IIF(m_lan =  ;
          'V',  ;
          'Dang tinh chi tieu ',  ;
          ecode2string('GLTCB0008')) +  ;
          ALLTRIM(ma_so) + ' ..'
     SELECT tkqt
     _ma_so = ALLTRIM(ma_so)
     _tk_no = STRTRAN(ALLTRIM(tk_no),  ;
              ' ', '')
     _tk_co = STRTRAN(ALLTRIM(tk_co),  ;
              ' ', '')
     _giam_tru = giam_tru
     _key = "Ma_dvcs LIKE '" +  ;
            ALLTRIM(m.ma_dvcs) +  ;
            "%'"
     IF  .NOT. EMPTY(_tk_no)
          _key = _key +  ;
                 " AND (Ps_no <> 0 AND (Tk LIKE '" +  ;
                 STRTRAN(ALLTRIM(_tk_no),  ;
                 ',',  ;
                 "%' OR Tk LIKE '" ;
                 ) + "%'))"
          IF  .NOT. EMPTY(_tk_co)
               _key = _key +  ;
                      " AND (Tk_du LIKE '" +  ;
                      STRTRAN(ALLTRIM(_tk_co),  ;
                      ',',  ;
                      "%' OR Tk_du LIKE '" ;
                      ) + "%')"
          ENDIF
     ELSE
          IF  .NOT. EMPTY(_tk_co)
               _key = _key +  ;
                      " AND (Ps_co <> 0 AND (Tk LIKE '" +  ;
                      STRTRAN(ALLTRIM(_tk_co),  ;
                      ',',  ;
                      "%' OR Tk LIKE '" ;
                      ) + "%'))"
          ENDIF
     ENDIF
     STORE 0 TO _luy_ke,  ;
           _luy_ke_nt, __luy_ke,  ;
           __luy_ke_nt,  ;
           _luy_ke_kt,  ;
           _luy_ke_kt_nt,  ;
           __luy_ke_kt,  ;
           __luy_ke_kt_nt,  ;
           _ky_nay, _ky_nay_nt,  ;
           __ky_nay, __ky_nay_nt,  ;
           __ky_truoc,  ;
           __ky_truocnt,  ;
           _ky_truoc,  ;
           _ky_truocnt
     sqlsum( ;
           'Ps_no + Ps_co, Ps_no_nt + Ps_co_nt', ;
           '_Luy_Ke_Kt, _Luy_ke__Kt_Nt', ;
           'ct00',_key +  ;
           " AND (Ngay_ct BETWEEN'" +  ;
           DTOS(ngay0_kt) +  ;
           "' AND '" +  ;
           DTOS(m.ngay_ct3) +  ;
           "')")
     sqlsum( ;
           'Ps_no + Ps_co, Ps_no_nt + Ps_co_nt', ;
           '_Luy_ke, _Luy_ke_nt', ;
           'ct00',_key +  ;
           " AND (Ngay_ct BETWEEN'" +  ;
           DTOS(ngay0_kn) +  ;
           "' AND '" +  ;
           DTOS(m.ngay_ct2) +  ;
           "')")
     sqlsum( ;
           'Ps_no + Ps_co, Ps_no_nt + Ps_co_nt', ;
           '_Ky_truoc, _Ky_truocnt', ;
           'ct00',_key +  ;
           " AND (Ngay_ct BETWEEN'" +  ;
           DTOS(m.ngay_ct0) +  ;
           "' AND '" +  ;
           DTOS(m.ngay_ct1 - 1) +  ;
           "')")
     sqlsum( ;
           'Ps_no + Ps_co, Ps_no_nt + Ps_co_nt', ;
           '_Ky_nay, _Ky_nay_nt', ;
           'ct00',_key +  ;
           " AND (Ngay_ct BETWEEN'" +  ;
           DTOS(m.ngay_ct1) +  ;
           "' AND '" +  ;
           DTOS(m.ngay_ct2) +  ;
           "')")
     IF _giam_tru = 1 .AND.  ;
        (EMPTY(_tk_no) .OR.  ;
        EMPTY(_tk_co))
          IF  .NOT. EMPTY(_tk_no)
               _key = "(Ps_co <> 0 AND (Tk LIKE '" +  ;
                      STRTRAN(ALLTRIM(_tk_no),  ;
                      ',',  ;
                      "%' OR Tk LIKE '" ;
                      ) + "%'))"
          ELSE
               _key = "(Ps_no <> 0 AND (Tk LIKE '" +  ;
                      STRTRAN(ALLTRIM(_tk_co),  ;
                      ',',  ;
                      "%' OR Tk LIKE '" ;
                      ) + "%'))"
          ENDIF
          _key = _key +  ;
                 " AND (Tk_du NOT LIKE '" +  ;
                 m_tk_kqkd +  ;
                 "%')"
          _key = '(' + _key +  ;
                 ") AND Ma_dvcs LIKE '" +  ;
                 ALLTRIM(m.ma_dvcs) +  ;
                 "%'"
          sqlsum( ;
                'Ps_no + Ps_co, Ps_no_nt + Ps_co_nt', ;
                '__Luy_Ke_Kt, __Luy_ke__Kt_Nt', ;
                'ct00',_key +  ;
                " AND (Ngay_ct BETWEEN'" +  ;
                DTOS(ngay0_kt) +  ;
                "' AND '" +  ;
                DTOS(m.ngay_ct3) +  ;
                "')")
          sqlsum( ;
                'Ps_no + Ps_co, Ps_no_nt + Ps_co_nt', ;
                '__Luy_ke, __Luy_ke_nt', ;
                'ct00',_key +  ;
                " AND (Ngay_ct BETWEEN'" +  ;
                DTOS(m_ngay_dau_nam) +  ;
                "' AND '" +  ;
                DTOS(m.ngay_ct2) +  ;
                "')")
          sqlsum( ;
                'Ps_no + Ps_co, Ps_no_nt + Ps_co_nt', ;
                '__Ky_truoc, __Ky_truocnt', ;
                'ct00',_key +  ;
                " AND (Ngay_ct BETWEEN'" +  ;
                DTOS(m.ngay_ct0) +  ;
                "' AND '" +  ;
                DTOS(m.ngay_ct1 -  ;
                1) + "')")
          sqlsum( ;
                'Ps_no + Ps_co, Ps_no_nt + Ps_co_nt', ;
                '__Ky_nay, __Ky_nay_nt', ;
                'ct00',_key +  ;
                " AND (Ngay_ct BETWEEN'" +  ;
                DTOS(m.ngay_ct1) +  ;
                "' AND '" +  ;
                DTOS(m.ngay_ct2) +  ;
                "')")
          _ky_truoc = _ky_truoc -  ;
                      __ky_truoc
          _ky_truocnt = _ky_truocnt -  ;
                        __ky_truocnt
          _luy_ke_kt = _luy_ke_kt -  ;
                       __luy_ke_kt
          _luy_ke_kt_nt = _luy_ke_kt_nt -  ;
                          __luy_ke_kt_nt
          _ky_nay = _ky_nay -  ;
                    __ky_nay
          _ky_nay_nt = _ky_nay_nt -  ;
                       __ky_nay_nt
          _luy_ke = _luy_ke -  ;
                    __luy_ke
          _luy_ke_nt = _luy_ke_nt -  ;
                       __luy_ke_nt
     ELSE
          IF _giam_tru = 1
               msgbox(IIF(m_lan =  ;
                     'V',  ;
                     'Chi tieu ',  ;
                     ecode2string('GLTCB0009')) +  ;
                     _ma_so +  ;
                     IIF(m_lan =  ;
                     'V',  ;
                     ' khai bao sai (Vua khai bao Tk_no, Tk_co va co giam tru)',  ;
                     ' is wrong'), ;
                     48, ;
                     m_itg_ver)
          ENDIF
     ENDIF
     SELECT tkqt
     REPLACE ky_truoc WITH  ;
             _ky_truoc,  ;
             ky_truocnt WITH  ;
             _ky_truocnt, lk_kt  ;
             WITH _luy_ke_kt,  ;
             lk_kt_nt WITH  ;
             _luy_ke_kt_nt,  ;
             ky_nay WITH _ky_nay,  ;
             ky_nay_nt WITH  ;
             _ky_nay_nt, luy_ke  ;
             WITH _luy_ke,  ;
             luy_ke_nt WITH  ;
             _luy_ke_nt
ENDSCAN
SELECT tkqt
SCAN FOR  .NOT. EMPTY(cach_tinh)
     WAIT WINDOW NOWAIT IIF(m_lan =  ;
          'V',  ;
          'Dang tinh chi tieu ',  ;
          ecode2string('GLTCB0010')) +  ;
          ALLTRIM(ma_so) + ' ..'
     STORE 0 TO _ky_truoc,  ;
           _ky_nay, _luy_ke,  ;
           _ky_truocnt,  ;
           _ky_nay_nt, _luy_ke_nt,  ;
           _luy_ke_kt,  ;
           _luy_ke_kt_nt
     currecno = RECNO()
     scal = ALLTRIM(cach_tinh)
     &sCal
     GOTO currecno
     REPLACE ky_truoc WITH  ;
             _ky_truoc,  ;
             ky_truocnt WITH  ;
             _ky_truocnt, ky_nay  ;
             WITH _ky_nay,  ;
             ky_nay_nt WITH  ;
             _ky_nay_nt, luy_ke  ;
             WITH _luy_ke,  ;
             luy_ke_nt WITH  ;
             _luy_ke_nt, lk_kt  ;
             WITH _luy_ke_kt,  ;
             lk_kt_nt WITH  ;
             _luy_ke_kt_nt
ENDSCAN
INDEX ON stt TAG stt
USE IN tkqt
USE IN akqt
SELECT (curselect)
ENDPROC
*
FUNCTION Cal
LPARAMETERS copr, scode
GOTO TOP
LOCATE FOR ALLTRIM(ma_so) ==  ;
       scode
_Ky_truoc = _Ky_truoc &cOpr Ky_truoc
_Ky_nay = _Ky_nay &cOpr Ky_nay
_Luy_ke_kt = _Luy_ke_Kt &cOpr Lk_Kt
_Luy_ke = _Luy_ke &cOpr Luy_ke
_Ky_truocnt = _Ky_truocnt &cOpr Ky_truocnt
_Ky_nay_nt = _Ky_nay_nt &cOpr Ky_nay_nt
_Luy_ke_nt = _Luy_ke_nt &cOpr Luy_ke_nt
_Luy_Ke_Kt_Nt = _Luy_Ke_Kt_Nt &cOpr Lk_Kt_nt
RETURN 0
ENDFUNC
*
PROCEDURE BrowseTable
SELECT 0
USE EXCLUSIVE (k_tmp + 'tKqt')  ;
    ALIAS tkqt ORDER Stt
ON KEY LABEL F4 DO Tao_nguon_tm
ON KEY LABEL F5 DO DETAIL
ON KEY LABEL F9 DO TOEXCEL
ON KEY LABEL F7 DO PRINT
_field = IIF(m_lan = 'V',  ;
         'Chi_tieu:60',  ;
         'Chi_tieu2:60')
IF m.rep_vnd_nt1 = 1
     __fields = _field +  ;
                ':H = _VFVOBGLTCB1:R , Ma_So: H=_VFVOBGLTCB2 :R, Th_Minh :H=_VFVOBGLTCB7 :R, ' +  ;
                'Ky_nay :P="@Z" + m_Ip_tien, Ky_Truoc : P="@Z" + m_Ip_tien, ' +  ;
                IIF( .NOT.  ;
                EMPTY(m.luy_ke),  ;
                'Lk_Kt :P="@Z" + m_Ip_tien, Luy_ke: P="@Z" + m_Ip_tien,',  ;
                '') +  ;
                'tk_no :10:R, tk_co :10:R, giam_tru :10:R, Cach_Tinh :10:R '
ELSE
     __fields = _field +  ;
                ':H = _VFVOBGLTCB1:R , Ma_So: H=_VFVOBGLTCB2 :R, Th_Minh :H=_VFVOBGLTCB7 :R, ' +  ;
                'Ky_Nay_nt :P="@Z" + m_Ip_tien_nt, Ky_truocnt: P="@Z" + m_Ip_tien_nt, ' +  ;
                IIF( .NOT.  ;
                EMPTY(m.luy_ke),  ;
                'Lk_kt_nt: P="@Z" + m_Ip_tien_nt ,Luy_ke_nt: P="@Z" + m_Ip_tien_nt,',  ;
                '') +  ;
                'Ky_nay :P="@Z" + m_Ip_tien, Ky_Truoc : P="@Z" + m_Ip_tien, ' +  ;
                IIF( .NOT.  ;
                EMPTY(m.luy_ke),  ;
                'Lk_Kt :P="@Z" + m_Ip_tien, Luy_ke: P="@Z" + m_Ip_tien,',  ;
                '') +  ;
                'tk_no :10:R, tk_co :10:R, giam_tru :10:R, Cach_Tinh :10:R '
ENDIF
BROWSE  FIELDS &__Fields  NAME oBrowse NOWAIT;
 WHEN Change_Color_Of_Browse(RECNO());
 NOAPPEND NODELETE NOMODIFY   WINDOW M_WinBrw;
 TITLE a_Report(l_Report,1) +  IIF(m_Lan = 'V', ". F4 - Tao nguon TM BCTC, F5 - Xem chi tiet, F7 - In, F9 - To Excel, Esc - Quay ra",;
ECode2String('GLTCB0011'))
obrowse.setall('DynamicFontBold', ;
              'Bold=1','Column')
obrowse.setall('DynamicForeColor', ;
              'IIF(Bold=1,m_Color_sum,0)', ;
              'Column')
DO hookobjectbrowse
BROWSE NOINIT
ON KEY LABEL F4
ON KEY LABEL F5
ON KEY LABEL F7
ON KEY LABEL F9
USE IN tkqt
ENDPROC

Procedure Tao_nguon_tm
	M_nam = RIGHT(ALLTRIM(STR(YEAR(M.Ngay_ct2))),2)
	
	select * from tKqt into table (K_Mau + [TKQKD]+M_NAM)
	Messagebox("Da tao bang nguon du lieu lap Thuyen minh BCTC!")
ENDPROC
*
PROCEDURE SortTable
LPARAMETERS aoftsort, tdest
PRIVATE curselect, currecno
curselect = SELECT()
SELECT *, 000001 AS Order, .F. AS isCal;
 FROM &aOftSort  INTO TABLE (tDest)
REPLACE iscal WITH (.T.) ALL FOR  ;
        EMPTY(cach_tinh)
SCAN
     _order = 1
     DO sortindex
ENDSCAN
ALTER TABLE (tdest) ALTER COLUMN  ;
      cach_tinh 'C' (254)
FOR i = 1 TO LEN('+-')
     coperator = SUBSTR('+-', i,  ;
                 1)
     REPLACE cach_tinh WITH  ;
             (STRTRAN(cach_tinh,  ;
             coperator, "')+" +  ;
             'Cal' + "('" +  ;
             coperator + "','"))  ;
             ALL
ENDFOR
REPLACE cach_tinh WITH ('=' +  ;
        'Cal' + "('+','" +  ;
        ALLTRIM(cach_tinh) +  ;
        "')") ALL FOR  .NOT.  ;
        EMPTY(cach_tinh)
INDEX ON order TAG order
USE
SELECT (curselect)
ENDPROC
*
PROCEDURE SortIndex
PRIVATE currecno, curorder,  ;
        curcalfield
IF iscal
     _order = _order + order
     RETURN
ENDIF
currecno = RECNO()
curorder = order
curcalfield = ALLTRIM(cach_tinh)
SCAN FOR ALLTRIM(ma_so) $  ;
     curcalfield .AND. RECNO() <>  ;
     currecno
     IF  .NOT. iscal
          DO sortindex
     ENDIF
     _order = _order + order
ENDSCAN
GOTO currecno
REPLACE iscal WITH .T., order  ;
        WITH _order
ENDPROC
*
PROCEDURE Print
PUSH KEY CLEAR
DO FORM (k_scx + 'gltc15A-f7')
IF m.nhan_huy <> 1
     POP KEY
     RETURN
ENDIF
m.frx = ALLTRIM(m.mau_rpt)
SET FILTER TO in_ck = 1
DO pr_report WITH .T.
SET FILTER TO
GOTO TOP
POP KEY
ENDPROC
*
PROCEDURE Detail
PRIVATE curselect, obrowse,  ;
        strsql
IF ( .NOT. EMPTY(cach_tinh)) .OR.  ;
   ky_nay = 0
     RETURN
ENDIF
curselect = SELECT()
SELECT tkqt
_tk_no = STRTRAN(ALLTRIM(tk_no),  ;
         ' ', '')
_tk_co = STRTRAN(ALLTRIM(tk_co),  ;
         ' ', '')
_giam_tru = giam_tru
_title = IIF(m_lan = 'V',  ;
         'Chi tiet cac Tk: ',  ;
         ecode2string('GLTCB0013')) +  ;
         _tk_no + IIF( .NOT.  ;
         EMPTY(_tk_no) .AND.   ;
         .NOT. EMPTY(_tk_co), ',',  ;
         '') + _tk_co + IIF(m_lan =  ;
         'V', ' . Esc-Quay ra',  ;
         ecode2string('GLTCB0014'))
_key = "(Ngay_ct BETWEEN '" +  ;
       DTOS(m.ngay_ct1) +  ;
       "' AND '" +  ;
       DTOS(m.ngay_ct2) +  ;
       "') AND Ma_dvcs LIKE '" +  ;
       ALLTRIM(m.ma_dvcs) + "%'"
IF  .NOT. EMPTY(_tk_no)
     _key = _key +  ;
            " AND (Tk LIKE '" +  ;
            STRTRAN(ALLTRIM(_tk_no),  ;
            ',',  ;
            "%' OR Tk LIKE '") +  ;
            "%')"
     IF _giam_tru <> 1
          _key = _key +  ;
                 ' AND Ps_no <> 0'
     ENDIF
     IF  .NOT. EMPTY(_tk_co)
          _key = _key +  ;
                 " AND (Tk_du LIKE '" +  ;
                 STRTRAN(ALLTRIM(_tk_co),  ;
                 ',',  ;
                 "%' OR Tk_du LIKE '" ;
                 ) + "%')"
     ENDIF
ELSE
     IF  .NOT. EMPTY(_tk_co)
          _key = _key +  ;
                 " AND (Tk LIKE '" +  ;
                 STRTRAN(ALLTRIM(_tk_co),  ;
                 ',',  ;
                 "%' OR Tk LIKE '" ;
                 ) + "%')"
     ENDIF
     IF _giam_tru <> 1
          _key = _key +  ;
                 ' AND Ps_co <> 0'
     ENDIF
ENDIF
strsql = 'SELECT Stt_rec, Ma_ct0, Stt_ct_nkc, Ngay_ct, So_ct, Ma_kh'
strsql = strsql +  ;
         ",CASE Tk_cn WHEN 1 THEN Ten_kh WHEN 2 THEN Ten_cc ELSE '' END AS Ten_kh"
strsql = strsql +  ;
         ",CASE Tk_cn WHEN 1 THEN Ten_kh2 WHEN 2 THEN Ten_cc2 ELSE '' END AS Ten_kh2"
strsql = strsql +  ;
         ', Ma_vv, Tk, Tk_du, Ps_no, Ps_co, Ma_nt, Ty_gia, Ps_no_nt, Ps_co_nt, Dien_giai, Ong_ba, Ma_ct'
strsql = strsql +  ;
         '	FROM gl WHERE ' +  ;
         _key
SQLEXEC(nconnhandle, strsql,  ;
       'tDetail')
IF _giam_tru = 1
     IF  .NOT. EMPTY(_tk_no)
          _key = "(Ps_co <> 0 AND (Tk_du = '" +  ;
                 STRTRAN(ALLTRIM(_tk_no),  ;
                 ',',  ;
                 "' OR Tk_du = '" ;
                 ) + "'))"
     ELSE
          _key = "(Ps_no <> 0 AND (Tk_du = '" +  ;
                 STRTRAN(ALLTRIM(_tk_co),  ;
                 ',',  ;
                 "' OR Tk_du = '" ;
                 ) + "'))"
     ENDIF
     _key = _key + " AND Tk<>'" +  ;
            m_tk_kqkd + "'"
     DELETE FOR &_Key
     PACK
ENDIF
SUM ps_no, ps_co, ps_no_nt,  ;
    ps_co_nt TO ntkps_no,  ;
    ntkps_co, ntkps_no_nt,  ;
    ntkps_co_nt 
APPEND BLANK
REPLACE dien_giai WITH IIF(m_lan =  ;
        'V',  ;
        'Tng pht sinh trong k',  ;
        ecode2string('GLTCB0015')),  ;
        ps_no WITH ntkps_no,  ;
        ps_co WITH ntkps_co,  ;
        ps_no_nt WITH ntkps_no_nt,  ;
        ps_co_nt WITH ntkps_co_nt,  ;
        stt_ct_nkc WITH -1
APPEND BLANK
REPLACE stt_ct_nkc WITH -2
INDEX ON DTOS(ngay_ct) +  ;
      TRANSFORM(stt_ct_nkc,  ;
      '@L 99') + so_ct TAG stt
PUSH KEY CLEAR
IF m.rep_vnd_nt1 = 1
     BROWSE FIELDS _ngay_ct =  ;
            IIF(EMPTY(ngay_ct),  ;
            SPACE(1),  ;
            TRANSFORM(DAY(ngay_ct),  ;
            '@L 99') + '/' +  ;
            TRANSFORM(MONTH(ngay_ct),  ;
            '@L 99') + '/' +  ;
            TRANSFORM(YEAR(ngay_ct),  ;
            '@L 9999')) :H =  ;
            _vfvobgltcb5 :6,  ;
            ma_ct0, so_ct, ma_kh,  ;
            ten_kh :24, dien_giai  ;
            :32, tk :10, tk_du  ;
            :10, ps_no :P = '@Z' +  ;
            m_ip_tien, ps_co :P =  ;
            '@Z' + m_ip_tien,  ;
            ma_vv, ma_ct NOAPPEND  ;
            NOEDIT NODELETE  ;
            WINDOW m_winbrw  ;
            NOWAIT TITLE _title  ;
            WHEN  ;
            change_color_of_browse(RECNO())  ;
            NAME obrowse
ELSE
     BROWSE FIELDS _ngay_ct =  ;
            IIF(EMPTY(ngay_ct),  ;
            SPACE(1),  ;
            TRANSFORM(DAY(ngay_ct),  ;
            '@L 99') + '/' +  ;
            TRANSFORM(MONTH(ngay_ct),  ;
            '@L 99') + '/' +  ;
            TRANSFORM(YEAR(ngay_ct),  ;
            '@L 9999')) :H =  ;
            _vfvobgltcb6 :6,  ;
            ma_ct0, so_ct, ma_kh,  ;
            ten_kh :24, dien_giai  ;
            :32, tk :10, tk_du  ;
            :10, ps_no_nt :P =  ;
            '@Z' + m_ip_tien_nt,  ;
            ps_co_nt :P = '@Z' +  ;
            m_ip_tien_nt, ma_nt,  ;
            ty_gia, ps_no :P =  ;
            '@Z' + m_ip_tien,  ;
            ps_co :P = '@Z' +  ;
            m_ip_tien, ma_vv,  ;
            ma_ct NOAPPEND NOEDIT  ;
            NODELETE WINDOW  ;
            m_winbrw NOWAIT TITLE  ;
            _title WHEN  ;
            change_color_of_browse(RECNO())  ;
            NAME obrowse
ENDIF
DO hookobjectbrowse
BROWSE NOINIT
POP KEY
USE IN tdetail
SELECT (curselect)
ENDPROC
*

*!*	----------------------------------------
*!*	PROCEDURE ToExcel
*!*	----------------------------------------
PROCEDURE ToExcel
	WAIT window "Dang thuc hien ..." nowait
	LOCAL liRowIndex, liColumnIndex, lcAlias
	
	SELECT tkqt
	
	lcCursor  = ALIAS() && table or cursor name

	SELECT ( lcCursor )
	loExcelSession = CREATEOBJECT('Excel.Application')

	WITH loExcelSession
	   .Visible  = .T.
	   .DisplayAlerts = .F.   && no messages displayed
	ENDWITH
	IF DIRECTORY("C:\EXCEL")
		_Temopen = 'C:\Excel\'
	ELSE
		IF DIRECTORY("D:\EXCEL")
			_Temopen = 'D:\Excel\'
		ELSE
			IF DIRECTORY("E:\EXCEL")
				_Temopen = 'E:\Excel\'
			ELSE
				_Temopen = FULLPATH(M_root) + 'Excel\'
			ENDIF
		ENDIF	
	ENDIF
	
	_Temopen = _Temopen + 'KQKD133'
	
	oExcelWorkbook = loExcelSession.APPLICATION.Workbooks.OPEN(_Temopen + ".XLS") 
	oActiveExcelSheet = oExcelWorkbook.Worksheets(1).ACTIVATE
	XLSHEET = oExcelWorkbook.Worksheets(1)
	
	XLSHEET.CELLS(1,1).VALUE = allt(M_Ten_Cty)
	XLSHEET.CELLS(2,1).VALUE = allt(M_Dia_chi)
	XLSHEET.CELLS(5,1).VALUE = [T ngy: ]  + DTOC(m.Ngay_Ct1) + [ n ngy: ] + DTOC(M.Ngay_Ct2)
	
	i = 7
	k= 0
	SELECT tkqt
	SCAN 
		i=i+1
		k=k+1
		CROW = ALLTRIM(STR(i))
		if i>8 
		    XlSheet.Rows("&cRow:&cRow").Insert
		endif
		
		
		XLSHEET.CELLS(i,1).VALUE = allt(Chi_tieu)
		XLSHEET.CELLS(i,2).VALUE = allt(Ma_so)
		XLSHEET.CELLS(i,3).VALUE = allt(Th_minh)
		IF ky_nay <> 0
			**XLSHEET.CELLS(i,4).VALUE = CHRTRAN(iif(Ky_nay < 0, [(], []) + alltrim(Trans(ABS(Ky_nay), "@Z " + M_IP_Tien)) + iif(Ky_nay < 0, [)], []), [ .], M_Num_Separator + M_Num_Point)
			XLSHEET.CELLS(i,4).VALUE = ky_nay
		ENDIF
		IF ky_truoc <> 0
			*XLSHEET.CELLS(i,5).VALUE = CHRTRAN(iif(Ky_truoc < 0, [(], []) + alltrim(Trans(ABS(Ky_truoc), "@Z " + M_IP_Tien)) + iif(Ky_truoc < 0, [)], []), [ .], M_Num_Separator + M_Num_Point)
			XLSHEET.CELLS(i,5).VALUE = ky_truoc
		ENDIF
		
		IF Bold = 0
			XlSheet.Rows("&cRow:&cRow").Font.Bold = .F.
		ELSE
			XlSheet.Rows("&cRow:&cRow").Font.Bold = .T.
		ENDIF
		
	ENDSCAN
	
	_Temsaveas = _Temopen + '_'+ DTOS(M.Ngay_ct1) + "_" + DTOS(M.Ngay_ct2)
	
	XLSHEET.SAVEAS(_Temsaveas)
	
	&&XLAPP.QUIT

RETURN

